@echo off

for %%i in (*.t) do (
  copy %%i %%~ni > nul
)

echo Compiling generators...

for %%i in (*.cpp) do (
   call g++ %%i -o %%~ni.exe
)

rem call g++ genRand.cpp -o genRand.exe
rem call g++ genRand2.cpp -o genRand2.exe

echo Generating tests...

genRand30_2 2 2 > 01
genRand30_2 100 100 > 02
genRand30_2 1000 1000 > 03
genRand30_2 2 1000 > 04
genRand30_2 1000 2 > 05
genRand30_good 5 5 > 06
genRand30 7 8 > 07
genRand30_good 23 16 > 08
genRand30_good 89 53 > 09
genRand30_good 45 25 > 10
genRand30_good 100 100 > 11
genRand30_good 889 666 > 12
genRand30_good 397 536 > 13
genRand30_good 999 997 > 14
genRand30_good 1000 1000 > 15

genRand50_good 3 3 > 16
genRand50_good 8 11 > 17
genRand50 12 12 > 18
genRand50_good 99 99 > 20
genRand50_good 566 239 > 21
genRand30_3 100 100 > 22
genRand30_3 1000 1000 > 23
genRand50_good 995 599 > 24
genRand50_good 1000 1000 > 25

genRand 10 1 > 29
genRand 10 2 > 30
genRand 10 3 > 31
genRand2 10 10 > 32
genRand 100 10 > 33
genRand 100 11 > 34
genRand2 100 100 > 35

genRand 1000 566 > 36
genRand 1000 53 > 37
genRand 1000 139 > 38
genRand 1000 158 > 39
genRand 1000 183 > 40
genRand 1000 3 > 41
genRand 1000 10 > 42
genRand 1000 20 > 43
genRand2 965 886 > 44
genRand 1000 1024 > 45
genRand 1000 100 > 46
genRand 1000 101 > 47
genRand 1000 102 > 48
genRand 1000 103 > 49
genRand2 1000 1000 > 50

rem call javac gen_%problem_name%.java -encoding utf8 
rem call java gen_%problem_name%
rem del gen_%problem_name%*.class

if EXIST ..\check.cpp g++ ..\check.cpp -o ..\check.exe -O2
if EXIST ..\check.dpr dcc32 -cc ..\check.dpr
if EXIST ..\Check.java (
pushd ..
	mkdir __chktmp
	call javac -classpath testlib4j.jar -d __chktmp Check.java -encoding utf8 
	pushd __chktmp
	call jar cf Check.jar *.class
	xcopy /Y Check.jar ..
	popd
	rmdir /S /Q __chktmp
popd
)

call tall sp
call docheck aa
